

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>&lt;no title&gt; &mdash; posydon 0+untagged.3754.gf69f455.dirty documentation</title>
  

  
  <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
        <script src="../_static/jquery.js"></script>
        <script src="../_static/underscore.js"></script>
        <script src="../_static/doctools.js"></script>
        <script src="../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../index.html" class="icon icon-home"> posydon
          

          
          </a>

          
            
            
              <div class="version">
                0+untagged.3754.gf69f455.dirty
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../install/index.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../run_mesa_grids/inifile.html">Configuration files for POSYDON</a></li>
<li class="toctree-l1"><a class="reference internal" href="../run_mesa_grids/dynamic/dynamic.html">Run a Dynamic MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../run_mesa_grids/fixed/fixed.html">Run a Fixed MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../PSyGrid/PSyGrid.html">The PSyGrid Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../PSyGrid/plot2D/plot2D.html">Showcase of 2D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../PSyGrid/plot1D/plot1D.html">Showcase of 1D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../SingleStar/SingleStar.html">The Single Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../BinaryStar/BinaryStar.html">The Binary Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../visualization/VH_diagram.html">Van den Heuvel diagrams</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">posydon</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../index.html" class="icon icon-home"></a> &raquo;</li>
        
      <li>&lt;no title&gt;</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
          
            <a href="../_sources/api/posydon.utils.common_functions.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <span class="target" id="module-posydon.utils.common_functions"></span><p>Common functions to be used while running populations.</p>
<dl class="py function">
<dt id="posydon.utils.common_functions.BSE_to_POSYDON">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">BSE_to_POSYDON</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">ktype</span></em>, <em class="sig-param"><span class="n">core_mass</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#BSE_to_POSYDON"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.BSE_to_POSYDON" title="Permalink to this definition">¶</a></dt>
<dd><p>Convert BSE numerical type to POSYDON string.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ktype</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.9)"><em>int</em></a>) – The BSE numerical type.</p></li>
<li><p><strong>core_mass</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – Core mass of the star.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The corresponding POSYDON string.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.9)">str</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.CO_radius">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">CO_radius</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">M</span></em>, <em class="sig-param"><span class="n">COtype</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#CO_radius"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.CO_radius" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculates the radius of a compact object based on it type (NS, BH, WD)
and its mass</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>M</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – CO mass in Msun</p></li>
<li><p><strong>COtype</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.9)"><em>str</em></a>) – Tyep of compact object. Accepted values: “BH”, “NS”, “WD”</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>Compact object radius in solar radii</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)">float</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.He_MS_lifetime">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">He_MS_lifetime</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">mass</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#He_MS_lifetime"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.He_MS_lifetime" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculates the lifetime of He burning in a star.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>mass</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#type" title="(in Python v3.9)"><em>type</em></a>) – Mass of star in solar masses</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>He MS time duration in yr.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)">float</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.POSYDON_to_BSE">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">POSYDON_to_BSE</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">star</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#POSYDON_to_BSE"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.POSYDON_to_BSE" title="Permalink to this definition">¶</a></dt>
<dd><p>Converts POSYDON state to BSE numerical type.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>star</strong> (<a class="reference internal" href="posydon.binary_evol.singlestar.html#posydon.binary_evol.singlestar.SingleStar" title="posydon.binary_evol.singlestar.SingleStar"><em>SingleStar</em></a>) – The star which state requires conversion.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The corresponding BSE numerical type.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.9)">int</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.Schwarzschild_Radius">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">Schwarzschild_Radius</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">M</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#Schwarzschild_Radius"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.Schwarzschild_Radius" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculate Schwarzschild Radius of BH with mass M.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>M</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – BH mass in Msun</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>Schwarzschild Radius in solar radii</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)">float</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.beaming">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">beaming</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">binary</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#beaming"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.beaming" title="Permalink to this definition">¶</a></dt>
<dd><p>Function to calculate the super-Eddington isotropic-equivalent accretion rate
<a href="#id16"><span class="problematic" id="id1">[1]_</span></a> and the beaming factor <a href="#id17"><span class="problematic" id="id2">[2]_</span></a> of a star. This does not change the intrinsic
accretion onto the accretor and is an observational effect due to the inflated
structure of the accretion disc that beams the outgoing X-ray emission. This is
important for observing super-Eddington X-ray sources (eg. ultraluminous X-ray sources).
In case of a BH we are assuming that it has zero spin which is not a good approximation
for high accretion rates.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>binary</strong> (<a class="reference internal" href="posydon.binary_evol.binarystar.html#posydon.binary_evol.binarystar.BinaryStar" title="posydon.binary_evol.binarystar.BinaryStar"><em>BinaryStar</em></a>) – The binary object.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The super-Eddington isotropic-equivalent accretion rate and beaming
factor respcetively in solar units.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.9)">list</a></p>
</dd>
</dl>
<p class="rubric">References</p>
<dl class="footnote brackets">
<dt class="label" id="id3"><span class="brackets">1</span></dt>
<dd><p>Shakura, N. I. &amp; Sunyaev, R. A. 1973, A&amp;A, 24, 337</p>
</dd>
<dt class="label" id="id4"><span class="brackets">2</span></dt>
<dd><p>King A. R., 2008, MNRAS, 385, L113</p>
</dd>
<dt class="label" id="id5"><span class="brackets">3</span></dt>
<dd><p>Podsiadlowski, Rappaport &amp; Han, 2003, MNRAS, 341, 385</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.bondi_hoyle">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">bondi_hoyle</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">binary</span></em>, <em class="sig-param"><span class="n">accretor</span></em>, <em class="sig-param"><span class="n">donor</span></em>, <em class="sig-param"><span class="n">idx</span><span class="o">=</span><span class="default_value">- 1</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#bondi_hoyle"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.bondi_hoyle" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculates the bondi-hoyle accretion rate of a binary <a href="#id18"><span class="problematic" id="id6">[1]_</span></a>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>binary</strong> (<a class="reference internal" href="posydon.binary_evol.binarystar.html#posydon.binary_evol.binarystar.BinaryStar" title="posydon.binary_evol.binarystar.BinaryStar"><em>BinaryStar</em></a>) – The binary which accretion rate is required.</p></li>
<li><p><strong>accretor</strong> (<a class="reference internal" href="posydon.binary_evol.singlestar.html#posydon.binary_evol.singlestar.SingleStar" title="posydon.binary_evol.singlestar.SingleStar"><em>SingleStar</em></a>) – The accretor in the binary.</p></li>
<li><p><strong>donor</strong> (<a class="reference internal" href="posydon.binary_evol.singlestar.html#posydon.binary_evol.singlestar.SingleStar" title="posydon.binary_evol.singlestar.SingleStar"><em>SingleStar</em></a>) – The donor in the binary.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The bondi-hoyle accretion rate in solar units.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)">float</a></p>
</dd>
</dl>
<p class="rubric">Notes</p>
<p>A approximation is used for the accretion rate[<a href="#id19"><span class="problematic" id="id20">2_</span></a>]
and the wind velocity of the donor is moddeled as in [<a href="#id21"><span class="problematic" id="id22">3_</span></a>].</p>
<p class="rubric">References</p>
<dl class="footnote brackets">
<dt class="label" id="id7"><span class="brackets">1</span></dt>
<dd><p>Bondi, H., &amp; Hoyle, F. 1944, MNRAS, 104, 273</p>
</dd>
<dt class="label" id="id8"><span class="brackets">2</span></dt>
<dd><p>Boffin, H. M. J., &amp; Jorissen, A. 1988, A&amp;A, 205, 155</p>
</dd>
<dt class="label" id="id9"><span class="brackets">3</span></dt>
<dd><p>Belczynski, K., Kalogera, V., Rasio, F. A., et al. 2008, ApJS, 174, 223</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.calculate_Patton20_values_at_He_depl">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">calculate_Patton20_values_at_He_depl</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">star</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#calculate_Patton20_values_at_He_depl"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.calculate_Patton20_values_at_He_depl" title="Permalink to this definition">¶</a></dt>
<dd><p>function that calculates carbon core mass and carbon abundance very close to carbon core ignition, for use fo Patton+2020 SN prescription</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>star</strong> (<em>POSYDON SingleStar object</em><em>, </em><em>where I assume that it has a history of its attributes</em>) – </p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul class="simple">
<li><p><em>None</em></p></li>
<li><p><em>It updates the following values in the star object</em></p></li>
<li><p><strong>co_core_mass_at_He_depletion</strong> (<em>float</em>) – co_core_mass at He core depletion (almost at the same time as carbon core ignition)</p></li>
<li><p><strong>avg_c_in_c_core_at_He_depletion</strong> (<em>float</em>) – avg carbon abundance inside CO_core_mass at He core depletion (almost at the same time as carbon core ignition)</p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.calculate_core_boundary">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">calculate_core_boundary</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">donor_mass</span></em>, <em class="sig-param"><span class="n">donor_star_state</span></em>, <em class="sig-param"><span class="n">profile</span></em>, <em class="sig-param"><span class="n">mc1_i</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">core_element_fraction_definition</span><span class="o">=</span><span class="default_value">None</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#calculate_core_boundary"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.calculate_core_boundary" title="Permalink to this definition">¶</a></dt>
<dd><p>Short summary.
Calculation of the shell where is the core - envelope boundary.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>donor_mass</strong> (<em>array</em>) – Profile column of enclosed mass of the star.</p></li>
<li><p><strong>donor_star_state</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#object" title="(in Python v3.9)"><em>object</em></a>) – The evolutionary state of the donor star</p></li>
<li><p><strong>profile</strong> (<em>numpy.array</em>) – Donor’s star profile from MESA</p></li>
<li><p><strong>mc1_i</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – core mass and total mass of the donor star.</p></li>
<li><p><strong>core_element_fraction_definition</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – The mass fraction of the envelope abundant chemical element at
the core-envelope boundary to derive the donor’s core mass from
the profile</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><strong>ind_core</strong> – The value of the shell position of the core - envelope boundary,
at the donor’s MESA profile</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.9)">int</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.check_state_of_star">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">check_state_of_star</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">star</span></em>, <em class="sig-param"><span class="n">i</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">star_CO</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#check_state_of_star"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.check_state_of_star" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the state of a SingleStar.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>star</strong> (<a class="reference internal" href="posydon.binary_evol.singlestar.html#posydon.binary_evol.singlestar.SingleStar" title="posydon.binary_evol.singlestar.SingleStar"><em>SingleStar</em></a>) – The star for which the state will be computed.</p></li>
<li><p><strong>i</strong> (<em>integer</em>) – Index of the model for which we want to calculate the state of the
SingleStar object. Default = -1 (the final).</p></li>
<li><p><strong>star_CO</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.9)"><em>bool</em></a>) – True if we want to assume a compact object (WD/NS/BH).
False if the state will be calculated by its attributes.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><strong>state</strong> – state at of the star object at index i of the history.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.9)">str</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.check_state_of_star_history_array">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">check_state_of_star_history_array</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">star</span></em>, <em class="sig-param"><span class="n">N</span><span class="o">=</span><span class="default_value">1</span></em>, <em class="sig-param"><span class="n">star_CO</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#check_state_of_star_history_array"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.check_state_of_star_history_array" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculate the evolutionary states with an array of history data.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>star</strong> (<a class="reference internal" href="posydon.binary_evol.singlestar.html#posydon.binary_evol.singlestar.SingleStar" title="posydon.binary_evol.singlestar.SingleStar"><em>SingleStar</em></a>) – The star for which the state will be computed.</p></li>
<li><p><strong>N</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.9)"><em>int</em></a>) – Number of history steps (from the end), to calculate the state.</p></li>
<li><p><strong>star_CO</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.9)"><em>bool</em></a>) – If <cite>True</cite>, assume it’s a compact object.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The state(s) in a list.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>list of str</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.cumulative_mass_transfer_flag">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">cumulative_mass_transfer_flag</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">MT_cases</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#cumulative_mass_transfer_flag"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.cumulative_mass_transfer_flag" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the cumulative MT string from a list of integer MT casses.</p>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.cumulative_mass_transfer_numeric">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">cumulative_mass_transfer_numeric</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">MT_cases</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#cumulative_mass_transfer_numeric"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.cumulative_mass_transfer_numeric" title="Permalink to this definition">¶</a></dt>
<dd><p>Summarize the history of MT cases in a short list of integers.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>MT_cases</strong> (<em>array-like</em>) – A list of the integer MT flags at sequential history steps.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul>
<li><p><em>list of int</em> – A shorter list of integer MT flags, following these rules:
i.   If undetermined MT at any step, it is indicated in the beginning</p>
<blockquote>
<div><p>(as a warning) and ignored later.</p>
</div></blockquote>
<ol class="lowerroman simple" start="2">
<li><p>If no RLO anywhere, then this is the only element in the returned
list (or the second if undetermined MT at any step). Intermediate
no-RLO phases (between RLO cases) are ignored.</p></li>
<li><p>Consequent same cases are reported only once (e.g., A, A, A -&gt; A.)</p></li>
</ol>
</li>
<li><p><em>The end result is a list of integers indicating whether undetermined MT</em></p></li>
<li><p><em>anywhere, if no RLO everywhere, or “changes” of MT cases.</em></p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.cumulative_mass_transfer_string">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">cumulative_mass_transfer_string</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">cumulative_integers</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#cumulative_mass_transfer_string"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.cumulative_mass_transfer_string" title="Permalink to this definition">¶</a></dt>
<dd><p>Convert a cumulative MT sequence to a string.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>cumulative_integers</strong> (<em>list of int</em>) – Typically, the output of <cite>cumulative_mass_transfer_numeric</cite>.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><p>A summarization of the mass-tranfer cases in the form of a string, as
opposed to the output of <cite>cumulative_mass_transfer_numeric</cite> (see this
function to understand the rules of summarization). The character <cite>?</cite>
in the beginning of the string indicates undetermined MT case at some
point of the evolution. <cite>no_RLO</cite> indicates no RLO at any evolutionary
step. <cite>caseA</cite>, <cite>caseB</cite>, etc., denote the corresponding MT cases. When
multiple cases are found, they are indicated only when the begin, and
are combined using <cite>/</cite>. For example:</p>
<p>?no_RLO     : undetermined MT at few steps, otherwise no RLO.
caseA       : case A MT only (possible no_RLO at some points).
?caseA/B    : undetermined MT somewhere, then case A, then case B.
caseA/B/A   : case A, then B, and A again (although unphysical).</p>
</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.9)">str</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.eddington_limit">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">eddington_limit</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">binary</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#eddington_limit"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.eddington_limit" title="Permalink to this definition">¶</a></dt>
<dd><p>Function to calculate the Eddington limit <a href="#id23"><span class="problematic" id="id10">[1]_</span></a> and the radtiative efficiency <a href="#id24"><span class="problematic" id="id11">[2]_</span></a> of a compact object.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>binary</strong> (<a class="reference internal" href="posydon.binary_evol.binarystar.html#posydon.binary_evol.binarystar.BinaryStar" title="posydon.binary_evol.binarystar.BinaryStar"><em>BinaryStar</em></a>) – The binary object.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The Eddington accretion limit and radtiative efficiency in solar units.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.9)">list</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.flip_stars">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">flip_stars</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">binary</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#flip_stars"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.flip_stars" title="Permalink to this definition">¶</a></dt>
<dd><p>Short summary.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>binary</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#type" title="(in Python v3.9)"><em>type</em></a>) – Description of parameter <cite>binary</cite>.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>Description of returned object.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/functions.html#type" title="(in Python v3.9)">type</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.get_binary_state_and_event_and_mt_case">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">get_binary_state_and_event_and_mt_case</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">binary</span></em>, <em class="sig-param"><span class="n">interpolation_class</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">i</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">verbose</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#get_binary_state_and_event_and_mt_case"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.get_binary_state_and_event_and_mt_case" title="Permalink to this definition">¶</a></dt>
<dd><p>Infer the binary state, event and mass transfer case.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>binary</strong> (<a class="reference internal" href="posydon.binary_evol.binarystar.html#posydon.binary_evol.binarystar.BinaryStar" title="posydon.binary_evol.binarystar.BinaryStar"><em>BinaryStar</em></a>) – The POSYDON binary star.</p></li>
<li><p><strong>i</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.9)"><em>int</em></a>) – The index of the history in which we want to calculate the state of the
binary object. Default (None) is the current state.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul class="simple">
<li><p><strong>binary_state</strong> (<em>str</em>) – One of ‘detached’, ‘contact’, ‘RLO1’ and ‘RLO2’.</p></li>
<li><p><strong>binary_event</strong> (<em>str</em>) – Either ‘oRLO1’ or ‘oRLO2’ (onset of RLO, the start of RLO).</p></li>
<li><p><strong>mass transfer case</strong> (<em>str</em>) – ‘caseA’, ‘caseB’, etc.</p></li>
</ul>
</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>If ‘detached’ then returns [‘detached’, None, None].
If ‘contact’ then returns [‘contact’, ‘oDoubleCE’,  None].
If RLO then returns either [‘RLO1’,  None, ‘caseXX’] or
[‘RLO2’,  None, ‘caseXX’] or maybe [‘RLO2’,  ‘oRLO2’, ‘caseXX’].</p>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.get_binary_state_and_event_and_mt_case_array">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">get_binary_state_and_event_and_mt_case_array</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">binary</span></em>, <em class="sig-param"><span class="n">N</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">verbose</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#get_binary_state_and_event_and_mt_case_array"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.get_binary_state_and_event_and_mt_case_array" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculate the evolutionary states with an array of history data.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>binary</strong> (<em>POSYDON BinaryStar object</em>) – </p></li>
<li><p><strong>N</strong> (<em>array</em>) – index of the history in which we want to calculate the state of the
SingleStar object</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul class="simple">
<li><p><strong>binary_state</strong> (<em>str(see in check_state_of_star)</em>)</p></li>
<li><p><em>binary_event</em></p></li>
<li><p><em>MT_case</em></p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.infer_mass_transfer_case">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">infer_mass_transfer_case</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">rl_relative_overflow</span></em>, <em class="sig-param"><span class="n">lg_mtransfer_rate</span></em>, <em class="sig-param"><span class="n">donor_state</span></em>, <em class="sig-param"><span class="n">verbose</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#infer_mass_transfer_case"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.infer_mass_transfer_case" title="Permalink to this definition">¶</a></dt>
<dd><p>Infer the mass-transfer case of a given star.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>rl_relative_overflow</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – </p></li>
<li><p><strong>lg_mtransfer_rate</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – </p></li>
<li><p><strong>donor_state</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.9)"><em>str</em></a>) – Values of star parameters at a specific step.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The mass-transfer case integer flag.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.9)">int</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.infer_star_state">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">infer_star_state</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">star_mass</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">surface_h1</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">center_h1</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">center_he4</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">center_c12</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">log_LH</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">log_LHe</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">log_Lnuc</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">star_CO</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#infer_star_state"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.infer_star_state" title="Permalink to this definition">¶</a></dt>
<dd><p>Infer the star state (corresponding to termination flags 2 and 3).</p>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.initialize_empty_array">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">initialize_empty_array</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">arr</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#initialize_empty_array"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.initialize_empty_array" title="Permalink to this definition">¶</a></dt>
<dd><p>Initialize an empty record array with NaNs and empty strings.</p>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.inspiral_timescale_from_orbital_period">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">inspiral_timescale_from_orbital_period</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">star1_mass</span></em>, <em class="sig-param"><span class="n">star2_mass</span></em>, <em class="sig-param"><span class="n">orbital_separation</span></em>, <em class="sig-param"><span class="n">eccentricity</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#inspiral_timescale_from_orbital_period"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.inspiral_timescale_from_orbital_period" title="Permalink to this definition">¶</a></dt>
<dd><p>Based on Peters 1964 <a class="reference external" href="https://journals.aps.org/pr/abstract/10.1103/PhysRev.136.B1224">https://journals.aps.org/pr/abstract/10.1103/PhysRev.136.B1224</a></p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>star1_mass</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – Mass of star 1 in Msun.</p></li>
<li><p><strong>star2_mass</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – Mass of star 2 in Msun.</p></li>
<li><p><strong>orbital_separation</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#type" title="(in Python v3.9)"><em>type</em></a>) – Binary separation in Rsun.</p></li>
<li><p><strong>eccentricity</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#type" title="(in Python v3.9)"><em>type</em></a>) – Eccentricity of the binary orbit. Must be 0 &lt;= ecc &lt;1.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The inspiral time scale of the two black holes.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)">float</a></p>
</dd>
</dl>
<p class="rubric">References</p>
<dl class="footnote brackets">
<dt class="label" id="id12"><span class="brackets">1</span></dt>
<dd><p>Peters 1964 Phys. Rev. 136, B1224</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.inspiral_timescale_from_separation">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">inspiral_timescale_from_separation</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">star1_mass</span></em>, <em class="sig-param"><span class="n">star2_mass</span></em>, <em class="sig-param"><span class="n">separation</span></em>, <em class="sig-param"><span class="n">eccentricity</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#inspiral_timescale_from_separation"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.inspiral_timescale_from_separation" title="Permalink to this definition">¶</a></dt>
<dd><p>Based on Peters 1964 <a class="reference external" href="https://journals.aps.org/pr/abstract/10.1103/PhysRev.136.B1224">https://journals.aps.org/pr/abstract/10.1103/PhysRev.136.B1224</a></p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>star1_mass</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – Mass of star 1 in Msun.</p></li>
<li><p><strong>star2_mass</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – Mass of star 2 in Msun.</p></li>
<li><p><strong>separation</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#type" title="(in Python v3.9)"><em>type</em></a>) – Binary separation in Rsun.</p></li>
<li><p><strong>eccentricity</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#type" title="(in Python v3.9)"><em>type</em></a>) – Eccentricity of the binary orbit. Must be 0 &lt;= ecc &lt;1.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The inspiral time scale of the two black holes.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)">float</a></p>
</dd>
</dl>
<p class="rubric">References</p>
<dl class="footnote brackets">
<dt class="label" id="id13"><span class="brackets">1</span></dt>
<dd><p>Peters 1964 Phys. Rev. 136, B1224</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.is_number">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">is_number</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">s</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#is_number"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.is_number" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.m_env_from_core_abundance_thresholds">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">m_env_from_core_abundance_thresholds</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">star</span></em>, <em class="sig-param"><span class="n">silence_error</span><span class="o">=</span><span class="default_value">True</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#m_env_from_core_abundance_thresholds"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.m_env_from_core_abundance_thresholds" title="Permalink to this definition">¶</a></dt>
<dd><p>function that calculates the envelope mass for different abundance thresholds of core boundary.
The results are meant to be used in collabration with the respective lambda_CE_*cent, lambda_CE_pure_He_star_10cent</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>star</strong> (<em>POSYDON SingleStar object</em><em>, </em><em>where I assume that it has a history of its attributes</em>) – </p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul class="simple">
<li><p><em>None</em></p></li>
<li><p><em>It updates the following values in the star object</em></p></li>
<li><p><strong>co_core_mass_at_He_depletion</strong> (<em>float</em>) – co_core_mass at He core depletion (almost at the same time as carbon core ignition)</p></li>
<li><p><strong>avg_c_in_c_core_at_He_depletion</strong> (<em>float</em>) – avg carbon abundance inside CO_core_mass at He core depletion (almost at the same time as carbon core ignition)</p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.monte_carlo_sampler">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">monte_carlo_sampler</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">x</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">y</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">size</span><span class="o">=</span><span class="default_value">1</span></em>, <em class="sig-param"><span class="n">x_lim</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">pdf</span><span class="o">=</span><span class="default_value">None</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#monte_carlo_sampler"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.monte_carlo_sampler" title="Permalink to this definition">¶</a></dt>
<dd><p>Generates random numbers from a 1d PDF using standard monte-carlo.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>x</strong> (<em>array_like</em>) – The x-values of the PDF.</p></li>
<li><p><strong>y</strong> (<em>array_like</em>) – The y-values of the PDF.</p></li>
<li><p><strong>size</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.9)"><em>int</em></a>) – The number of random numbers to generate.</p></li>
<li><p><strong>x_lim</strong> (<em>array float</em>) – The boundary where the pdf function is defined if passed as pdf.</p></li>
<li><p><strong>pdf</strong> (<em>func</em>) – The pdf function</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>An array with <cite>size</cite> random numbers generated from the PDF.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>ndarray</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.orbital_period_from_separation">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">orbital_period_from_separation</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">separation</span></em>, <em class="sig-param"><span class="n">m1</span></em>, <em class="sig-param"><span class="n">m2</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#orbital_period_from_separation"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.orbital_period_from_separation" title="Permalink to this definition">¶</a></dt>
<dd><p>3rd Kepler law</p>
<p>Receives:
separation_solar -&gt; orbital separation (semi-major axis) in rsun
m1_solar, m2_solar -&gt; masses of the two stars in solar units</p>
<p>Returns:
period_days: orbital period in days</p>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.orbital_separation_from_period">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">orbital_separation_from_period</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">period_days</span></em>, <em class="sig-param"><span class="n">m1_solar</span></em>, <em class="sig-param"><span class="n">m2_solar</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#orbital_separation_from_period"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.orbital_separation_from_period" title="Permalink to this definition">¶</a></dt>
<dd><p>3rd Kepler law</p>
<p>Receives:
period_days -&gt; orbital period in days
m1, m2 -&gt; masses of the two stars in solar units</p>
<p>Returns:
separation: orbital semi-major axis in solar radii</p>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.roche_lobe_radius">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">roche_lobe_radius</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">q</span></em>, <em class="sig-param"><span class="n">a_orb</span><span class="o">=</span><span class="default_value">1</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#roche_lobe_radius"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.roche_lobe_radius" title="Permalink to this definition">¶</a></dt>
<dd><p>Approximation of Roche lobe radius from Eggleton (1983)</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>q</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – Dimensionless mass ratio = MRL/Mcomp, where MRL is the mass of the star we calculate the RL and Mcomp is the mass of its companion star.</p></li>
<li><p><strong>a_orb</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – Orbital separation. The units input for this one will be the same as the Roche lobe calculated</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>Roche lobe radius in similar units as a_orb</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)">float</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.rzams">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">rzams</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">m</span></em>, <em class="sig-param"><span class="n">z</span><span class="o">=</span><span class="default_value">0.02</span></em>, <em class="sig-param"><span class="n">Zsun</span><span class="o">=</span><span class="default_value">0.02</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#rzams"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.rzams" title="Permalink to this definition">¶</a></dt>
<dd><p>A function to evaluate the zero age main sequence radius <a href="#id25"><span class="problematic" id="id14">[1]_</span></a>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>m</strong> (<em>array_like</em>) – The masses of the stars in Msun.</p></li>
<li><p><strong>z</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – The metallicity of the star.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>An array of the same shape as <cite>m</cite> that contains the ZAMS radii of the stars in Rsun.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>ndarray</p>
</dd>
</dl>
<p class="rubric">References</p>
<dl class="footnote brackets">
<dt class="label" id="id15"><span class="brackets">1</span></dt>
<dd><p>Tout C. A., Pols O. R., Eggleton P. P., Han Z., 1996, MNRAS, 281, 257</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="posydon.utils.common_functions.spin_stable_mass_transfer">
<code class="sig-prename descclassname">posydon.utils.common_functions.</code><code class="sig-name descname">spin_stable_mass_transfer</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">star_mass_preMT</span></em>, <em class="sig-param"><span class="n">star_mass_postMT</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/utils/common_functions.html#spin_stable_mass_transfer"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.utils.common_functions.spin_stable_mass_transfer" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculate the spin of an accreting BH under stable mass transfer as in Thorne 1974 eq. 2a</p>
</dd></dl>



           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2019, Tassos Fragkos.

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>